/*	$NetBSD: ep93xx_space.c,v 1.1 2004/12/22 19:08:16 joff Exp $ */

/*
 * Copyright (c) 2004 Jesse Off
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Ichiro FUKUHARA.
 * 4. The name of the company nor the name of the author may be used to
 *    endorse or promote products derived from this software without specific
 *    prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ICHIRO FUKUHARA ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ICHIRO FUKUHARA OR THE VOICES IN HIS HEAD BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * $NetBSD: ep93xx_space.c,v 1.1 2004/12/22 19:08:16 joff Exp $
 */

#include <sys/cdefs.h>
__FBSDID("$FreeBSD$");

/*
 * bus_space I/O functions for ep93xx
 */

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/bus.h>

#include <machine/bus.h>

#include <arm/ep93xx/ep93xxreg.h>
#include <arm/ep93xx/ep93xxvar.h>

/* Proto types for all the bus_space structure functions */
bs_protos(ep93xx);
bs_protos(generic);
bs_protos(generic_armv4);

struct bus_space ep93xx_bs_tag = {
	/* cookie */
	(void *) 0,

	/* mapping/unmapping */
	NULL,
	NULL,
	NULL,

	/* allocation/deallocation */
	NULL,
	NULL,

	/* barrier */
	ep93xx_bs_barrier,

	/* read (single) */
        generic_bs_r_1,
        generic_armv4_bs_r_2,
        generic_bs_r_4,
	NULL,

        /* read multiple */
        generic_bs_rm_1,
        generic_armv4_bs_rm_2,
        generic_bs_rm_4,
	NULL,
        /* read region */
        generic_bs_rr_1,
        generic_armv4_bs_rr_2,
        generic_bs_rr_4,
	NULL,

        /* write (single) */
        generic_bs_w_1,
        generic_armv4_bs_w_2,
        generic_bs_w_4,
	NULL,

        /* write multiple */
        generic_bs_wm_1,
        generic_armv4_bs_wm_2,
        generic_bs_wm_4,
	NULL,

        /* write region */
        generic_bs_wr_1,
        generic_armv4_bs_wr_2,
        generic_bs_wr_4,
	NULL,
        /* set multiple */
	NULL,
	NULL,
	NULL,
	NULL,

        /* set region */
	NULL,
        generic_armv4_bs_sr_2,
        generic_bs_sr_4,
	NULL,
        /* copy */
	NULL,
        generic_armv4_bs_c_2,
	NULL,
	NULL,
};

void
ep93xx_bs_barrier(void *t, bus_space_handle_t bsh, bus_size_t offset,
    bus_size_t len, int flags)
{

	/* Nothing to do. */
}
